ViennaCL - The Vienna Computing Library: viennacl::device_specific::template_base_impl< TemplateType, ParametersType > Class Template Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Protected Attributes | List of all members
viennacl::device_specific::template_base_impl< TemplateType, ParametersType > Class Template Reference

`#include <template_base.hpp>`

Inheritance diagram for viennacl::device_specific::template_base_impl< TemplateType, ParametersType >:

## Public Types
typedef ParametersType | parameters_type

## Public Member Functions
| template_base_impl (parameters_type const &parameters, binding_policy_t binding_policy)
| The constructor. More...
parameters_type const & | parameters () const
tools::shared_ptr< template_base > | clone () const
int | check_invalid (statements_container const &statements, viennacl::ocl::device const &device) const
| returns whether or not the profile has undefined behavior on particular device More...
Public Member Functions inherited from viennacl::device_specific::template_base
| template_base (binding_policy_t binding_policy)
virtual | ~template_base ()
std::vector< std::string > | generate (std::string const &kernel_prefix, statements_container const &statements, viennacl::ocl::device const &device)
virtual void | enqueue (std::string const &kernel_prefix, std::vector< lazy_program_compiler > &programs, statements_container const &statements)=0

## Protected Attributes
parameters_type | p_

## Additional Inherited Members
Protected Member Functions inherited from viennacl::device_specific::template_base
void | set_arguments (statements_container const &statements, viennacl::ocl::kernel &kernel, unsigned int &current_arg)
Static Protected Member Functions inherited from viennacl::device_specific::template_base
static void | generate_prototype (utils::kernel_generation_stream &stream, std::string const &name, std::string const &first_arguments, std::vector< mapping_type > const &mappings, statements_container const &statements, std::map< std::string, unsigned int > const &widths)
static void | generate_prototype (utils::kernel_generation_stream &stream, std::string const &name, std::string const &first_arguments, std::vector< mapping_type > const &mappings, statements_container const &statements)
static void | fetching_loop_info (fetching_policy_type policy, std::string const &bound, utils::kernel_generation_stream &stream, std::string &init, std::string &upper_bound, std::string &inc, std::string const &domain_id, std::string const &domain_size)
static bool | is_node_trans (scheduler::statement::container_type const &array, vcl_size_t root_idx, leaf_t leaf_type)
static std::string | append_simd_suffix (std::string const &str, unsigned int i)
static bool | is_striding_operator (scheduler::statement_node const &node)
static bool | has_strided_access (statements_container const &statements)
static vcl_size_t | vector_size (scheduler::statement_node const &node, bool up_to_internal_size)
static void | element_wise_loop_1D (utils::kernel_generation_stream &stream, loop_body_base const &loop_body, fetching_policy_type fetch, unsigned int simd_width, std::string const &i, std::string const &bound, std::string const &domain_id, std::string const &domain_size)
static std::string | vstore (unsigned int simd_width, std::string const &value, std::string const &offset, std::string const &ptr)
static std::string | vload (unsigned int simd_width, std::string const &offset, std::string const &ptr)

## Detailed Description

### template<class TemplateType, class ParametersType>
class viennacl::device_specific::template_base_impl< TemplateType, ParametersType >

Definition at line 519 of file template_base.hpp.

## Member Typedef Documentation

template<class TemplateType, class ParametersType>

typedef ParametersType viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::parameters_type

Definition at line 527 of file template_base.hpp.

## Constructor & Destructor Documentation

template<class TemplateType, class ParametersType>

viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::template_base_impl | ( | parameters_type const & | parameters,
|  | binding_policy_t | binding_policy
| ) |  |
| inline

The constructor.

Definition at line 530 of file template_base.hpp.

## Member Function Documentation

template<class TemplateType, class ParametersType>

int viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::check_invalid | ( | statements_container const & | statements,
|  | viennacl::ocl::device const & | device
| ) |  | const
| inlinevirtual

returns whether or not the profile has undefined behavior on particular device

Implements viennacl::device_specific::template_base.

Definition at line 543 of file template_base.hpp.

template<class TemplateType, class ParametersType>

tools::shared_ptr<template_base> viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::clone | ( |  | ) | const
| inlinevirtual

Implements viennacl::device_specific::template_base.

Definition at line 537 of file template_base.hpp.

template<class TemplateType, class ParametersType>

parameters_type const& viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::parameters | ( |  | ) | const
| inline

Definition at line 532 of file template_base.hpp.

## Member Data Documentation

template<class TemplateType, class ParametersType>

parameters_type viennacl::device_specific::template_base_impl< TemplateType, ParametersType >::p_
| protected

Definition at line 590 of file template_base.hpp.

The documentation for this class was generated from the following file:

- viennacl/device_specific/templates/template_base.hpp